app/app/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.static import static

from app import settings
from main import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls', namespace="main")),
    path('catalog/', include('goods.urls', namespace="catalog")),
    path('user/', include('users.urls', namespace="user")),
    path('cart/', include('carts.urls', namespace="cart")),
]

if settings.DEBUG:
    urlpatterns += [
        path("__debug__/", include("debug_toolbar.urls")),
    ]
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

app/carts/urls.py
from django.urls import path
from carts import views

app_name = 'carts'

urlpatterns = [
    path('cart_add/', views.cart_add, name='cart_add'),
    path('cart_change/', views.cart_change, name='cart_change'),
    path('cart_remove/', views.cart_remove, name='cart_remove'),
]

app/carts/models.py
from django.db import models
from goods.models import Products
from users.models import User


class CartQueryset(models.QuerySet):

    def total_price(self):
        return sum(cart.products_price() for cart in self)

    def total_quantity(self):
        if self:
            return sum(cart.quantity for cart in self)
        return 0


class Cart(models.Model):
    user = models.ForeignKey(to=User, on_delete=models.CASCADE, blank=True, null=True, verbose_name="Users")
    product = models.ForeignKey(to=Products, on_delete=models.CASCADE, verbose_name="Product")
    quantity = models.PositiveIntegerField(default=0, verbose_name="Quantity")
    session_key = models.CharField(max_length=32, blank=True, null=True)
    created_timestamp = models.DateTimeField(auto_now_add=True, verbose_name="Added date")

    class Meta:
        db_table = 'cart'
        verbose_name = "Cart"
        verbose_name_plural = "Carts"

    objects = CartQueryset.as_manager()
    def products_price(self):
        return round(self.product.sell_price() * self.quantity, 2)

    def __str__(self):
        if self.user:
            return f"Cart {self.user.username} | Product {self.product.name} | Quantity {self.quantity}"
        return f"Anonymous cart | Cart {self.product.name} | Quantity {self.quantity}"

app/carts/views.py
from django.http import HttpResponse, JsonResponse
from django.shortcuts import render, redirect
from django.template.loader import render_to_string

from carts.models import Products, Cart
from carts.utils import get_user_carts


def cart_add(request):

    product_id = request.POST.get('product_id')
    product = Products.objects.get(id=product_id)

    if request.user.is_authenticated:
        carts = Cart.objects.filter(user=request.user, product=product)

        if carts.exists():
            cart = carts.first()
            if cart:
                cart.quantity += 1
                cart.save()

        else:
            Cart.objects.create(user=request.user, product=product, quantity=1)


    else:
        carts = Cart.objects.filter(
            session_key=request.session.session_key, product=product, quantity=1
        )

        if carts.exists():
            cart = carts.first()
            if cart:
                cart.quantity += 1
                cart.save()

        else:
            Cart.objects.create(session_key=request.session.session_key, product=product, quantity=1)

    user_cart = get_user_carts(request)
    cart_items_html = render_to_string(
        "carts/includes/included_cart.html", {"carts": user_cart}, request=request)

    response_data = {
        "message": "Product added",
        "cart_items_html": cart_items_html,
    }

    return JsonResponse(response_data)


def cart_change(request):
    cart_id = request.POST.get('cart_id')
    quantity = request.POST.get('quantity')

    cart = Cart.objects.get(id=cart_id)

    cart.quantity = quantity
    cart.save()
    updated_quantity = cart.quantity

    cart = get_user_carts(request)
    cart_item_html = render_to_string(
        "carts/includes/included_cart.html",
        {"carts": cart}, request=request
    )

    response_data = {
        "message": "Product's quantity changed",
        "cart_item_html": cart_item_html,
        "quantity": updated_quantity,
    }

    return JsonResponse(response_data)

def cart_remove(request):

    cart_id = request.POST.get('cart_id')

    cart = Cart.objects.get(id=cart_id)
    quantity = cart.quantity
    cart.delete()

    user_cart = get_user_carts(request)
    cart_items_html = render_to_string("carts/includes/included_cart.html",
                                       {"carts": user_cart}, request=request)

    response_data = {
        "message": "Product removed",
        "cart_items_html": cart_items_html,
        "quantity_deleted": quantity,
    }
    return JsonResponse(response_data)

app/carts/templates/carts/includes/included_cart.html
{% load static %}

<div class="card mb-3 text-bg-light shadow-lg">
    {% for cart in carts %}
        <div class="card-header">
        <h5 class="card-title">{{ cart.product.name }}</h5>
    </div>
    <ul class="list-group list-group-flush">
        <li class="list-group-item">
            <div class="row text-center">
                <div class="col p-0">
                    <div class="input-group">
                        <span class="input-group-btn">
                            <button type="button" class="btn btn-dark btn-sm decrement"
                                data-cart-id="{{ cart.id }}"
                                    data-cart-change-url="{% url 'cart:cart_change' %}">
                                {% csrf_token %}
                                -</button>
                        </span>
                        <input type="text" class="form-control number" value="{{ cart.quantity }}"
                            readonly>
                        <span class="input-group-btn">
                            <button type="button" class="btn btn-dark btn-sm increment"
                                data-cart-id="{{ cart.id }}"
                                    data-cart-change-url="{% url 'cart:cart_change' %}">
                                {% csrf_token %}
                                +</button>
                        </span>
                    </div>
                </div>
                <div class="col p-0">
                    <p>x {{ cart.product.sell_price }} = </p>
                </div>
                <div class="col p-0"><strong>{{ cart.products_price }} $</strong></div>
                <div class="col p-0">
                    <a href="{% url 'cart:cart_remove' %}" class="remove-from-cart"
                       data-cart-id="{{ cart.id }}">
                        {% csrf_token %}
                        <img class="mx-1" src="{% static 'deps/icons/trash3-fill.svg' %}"
                            alt="Catalog Icon" width="16" height="16">
                    </a>
                </div>
            </div>
        </li>
    </ul>
    {% endfor %}
</div>
<div class="card mb-3 shadow-lg">
    <div class="card-footer">
        <p class="float-left">Итого <strong>{{ carts.total_quantity }}</strong> товар(а) на сумму</p>
        <h4 class="float-left"><strong>{{ carts.total_price }} $</strong></h4>
    </div>
</div>